(define debug-on #t)

(define (debug-write x)
  (if debug-on (write x)))

(define (debug-newline)
  (if debug-on (newline)))

(define (remove-repetitions the-list)
  (cond ((< (length the-list) 2) 
         the-list)
        ((equal? (car the-list) (cadr the-list)) 
         (remove-repetitions (cdr the-list)))
        (else 
         (cons (car the-list) 
               (remove-repetitions (cdr the-list))))))

(define (ordering-function a b)
                                        ; a and b should be lists of the same length (> 0)
  (cond ((= (length a) 1) (<= (car a) (car b)))
        ((> (length a) 1) 
         (cond ((< (car a) (car b)) #t)
               ((> (car a) (car b)) #f)
               (else 
                (ordering-function (cdr a) (cdr b)))))
        (else
         (error "bad condition in sorted-union"))))

                                        ; sorts the-list and then calls remove-repetitions
(define (sorted-union the-list)
  (remove-repetitions (vector->list (sort! (list->vector the-list) ordering-function))))

                                        ;(define (get-next-iteration boundary-iterations expansion-function)
                                        ;	(let ((new-boundary (sorted-union (car boundary-iterations))))


                                        ;(define (expansion-expander point dimensions pre-processing-predicates)
                                        ; create a new function that evaluates all the predicates together
                                        ;	(define (all-together-now x)
                                        ;	)

                                        ; takes a list of points and returns a canteen encoding them
(define (Create-Trie list-of-points)
  (cond 
   ((or (null? list-of-points) (null? (car list-of-points))) '())
   ((= 1 (length (car list-of-points))) list-of-points)
   (else 
                                        ; get sorted-union 
    (let ((SuLOL (sorted-union list-of-points))
          (myTrie '()))
      (let lp ((cur-header-element (caar list-of-points))
               (cur-list-of-points '())
               (remaining-points list-of-points))
        (cond 
         ((null? remaining-points) 
          (if (not (null? cur-list-of-points))
              (set! myTrie 
                    (append myTrie 
                            (list (list cur-header-element 
                                        (Create-Trie (map cdr cur-list-of-points)))))))
          myTrie)
         ((equal? cur-header-element (caar remaining-points))
          (lp cur-header-element 
              (append cur-list-of-points 
                      (list (car remaining-points)))
              (cdr remaining-points)))
         (else 
          (if (not (null? cur-list-of-points))
              (set! myTrie 
                    (append myTrie 
                            (list (list cur-header-element 
                                        (Create-Trie (map cdr cur-list-of-points)))))))
          (lp (caar remaining-points)	
              '() 
              remaining-points))))))))

                                        ; takes a list of variables and a list of points (with only those variables 
                                        ; and creates a canteen. vars MUST be in sorted order and distinct
(define (Create-Canteen vars points)
  (list vars (Create-Trie points)))

                                        ; assumes the two lists are sorted and numerical
(define (get-union listA listB)
  (cond 
   ((null? listA) listB)
   ((null? listB) listA)
   ((equal? (car listA) (car listB)) 
    (cons (car listA) 
          (get-union (cdr listA) (cdr listB))))
   ((< (car listA) (car listB)) 
    (cons (car listA) 
          (get-union (cdr listA) listB)))
   (else
    (cons (car listB)
          (get-union listA (cdr listB))))))

(define (get-intersection listA listB)
  (cond 
   ((or (null? listA) (null? listB)) '())
   ((= (car listA) (car listB)) 
    (cons (car listA) 
          (get-intersection (cdr listA) (cdr listB))))
   ((< (car listA) (car listB))
    (get-intersection (cdr listA) listB))
   ((> (car listA) (car listB))
    (get-intersection listA (cdr listB)))))

(define (sort-not-simple-answers non-trivial-answers)
  (define (special-ordering a b)
    (ordering-function (car a) (car b)))
  (vector->list (sort! (list->vector non-trivial-answers) special-ordering)))

                                        ; sigh... suboptimally coded (algorithmically) :(
(define (get-sub-canteen desired-vars canteen)		
  (let ((simple-answer '())
        (not-simple-answer '()))
    (define (crawl-trie 
             cur-desired-list
             cur-undesired-list 
             cur-trie 
             remaining-vars 
             remaining-desired-vars)
      (debug-write "... Crawling trie") (debug-newline)
      (debug-write "		") (debug-write cur-desired-list) (debug-newline)
      (debug-write "		") (debug-write cur-undesired-list) (debug-newline)
      (debug-write "		") (debug-write cur-trie) (debug-newline)
      (debug-write "		") (debug-write remaining-vars) (debug-newline)
      (debug-write "		") (debug-write remaining-desired-vars) (debug-newline)
      (cond 
       ((null? remaining-vars)
        (debug-write "				Cond case 0") (debug-newline)
					; no more remaining variables, time to record result whatever it is
        (set! not-simple-answer 
              (cons (list cur-desired-list cur-undesired-list) not-simple-answer))
        (set! simple-answer 
              (cons cur-desired-list simple-answer)))
       ((= 1 (length remaining-vars))
        (debug-write "				Cond case 1") (debug-newline)
					; exactly 1 remaining variable... recall to trie to get to case 0
        (for-each 
         (lambda (x) 
           (crawl-trie 							
            (if (null? remaining-desired-vars)
                cur-desired-list 
                (append cur-desired-list x))
            (append cur-undesired-list x)
            '()
            '()
            '()))
         cur-trie))
       ((not (null? remaining-desired-vars))
        (cond 
         ((= (car remaining-vars) (car remaining-desired-vars))
          (debug-write "				Cond case 2") (debug-newline)
                                        ; desired-var in sight... time to note it down!
          (for-each 
           (lambda (x) 
             (crawl-trie 
              (append cur-desired-list (list (car x)))
              (append cur-undesired-list (list (car x)))
              (cadr x)
              (cdr remaining-vars)
              (if (null? remaining-desired-vars) 
                  '() 
                  (cdr remaining-desired-vars))))
           cur-trie))
         (else
          (debug-write "				Cond case 3") (debug-newline)
                                        ; (car remaining-var) is not desired
          (for-each 
           (lambda (x) 
             (crawl-trie 
              cur-desired-list
              (append cur-undesired-list (list (car x)))
              (cadr x)
              (cdr remaining-vars)
              remaining-desired-vars))
           cur-trie))))
       (else
        (debug-write "				Cond case 4") (debug-newline)
					; no more remaining-desired-vars!
        (for-each 
         (lambda (x) 
           (crawl-trie
            cur-desired-list
            (append cur-undesired-list (list (car x)))
            (cadr x) 
            (cdr remaining-vars)
            '()))
         cur-trie))))
    (debug-write "Trying to crawl-trie...") (debug-newline)
    (crawl-trie '() '() (cadr canteen) (car canteen) desired-vars)
    (debug-write "Trie crawled... trying to sort-union the simple answer...") (debug-newline)
    (set! simple-answer 
          (if (null? desired-vars)
              '(())
              (sorted-union simple-answer)))
    (debug-write "Simple answer sort-union'ed... returning result.") (debug-newline)
    (list 
     simple-answer 
     (if (null? desired-vars)
         not-simple-answer
         (sort-not-simple-answers not-simple-answer)))))

                                        ; filters alpha to only have headers given in beta
(define (filter1 alpha beta)
  (debug-write "------Call to Filter 1------") (debug-newline)
  (debug-write "alpha = ") (debug-write alpha) (debug-newline)
  (debug-write "beta = ")  (debug-write beta)  (debug-newline)
  (cond 
   ((or (null? alpha) (null? beta)) 
    (debug-write "Cond Case 0!") (debug-newline)
    '())
   ((equal? (caar alpha) (car beta))
    (debug-write "Cond Case 1!") (debug-newline)
    (cons (car alpha) 
          (filter1 (cdr alpha) beta)))
   ((ordering-function (caar alpha) (car beta)) ; must be <
    (debug-write "Cond Case 2!") (debug-newline)
    (filter1 (cdr alpha) beta))
   (else 
    (debug-write "Cond Case 3!") (debug-newline)
    (filter1 alpha (cdr beta)))))

                                        ; Blockerize basically takes alpha of the form:
                                        ; ((a baz1) (a baz2) (a baz3) (b baz4) (b baz5))
                                        ; into
                                        ; ((a (baz1 baz2 baz3)) (b (baz4 baz5)))
(define (blockerize alpha)
  (let lp ((cur-block (caar alpha))
           (cur-entries '())
           (remaining-alpha alpha))
    (debug-write "----------- blockerize call! ------------") (debug-newline)
    (debug-write "cur-block = ") (debug-write cur-block) (debug-newline)
    (debug-write "cur-entries = ") (debug-write cur-entries) (debug-newline)
    (debug-write "remaining-alpha = ") (debug-write remaining-alpha) (debug-newline)
    (cond 
     ((null? remaining-alpha) 
      (debug-write "Cond Case 0!") (debug-newline)
      (if (null? cur-entries)
          '()
          (list (cons cur-block cur-entries))))
     ((equal? (caar remaining-alpha) cur-block)
      (debug-write "Cond Case 1!") (debug-newline)
      (lp cur-block 
          (append cur-entries 
                  (list (cadr (car remaining-alpha)))) 
          (cdr remaining-alpha)))
     (else 
      (debug-write "Cond Case 2!") (debug-newline)
      (cons (cons cur-block cur-entries) 
            (if (null? (cdr remaining-alpha))
                '()
                (lp (caar remaining-alpha)
                    '()
                    remaining-alpha)))))))

                                        ; finds all matching blocks (by header) and apply's operator on them
(define (block-matcher blocksA blocksB operator)
  (debug-write "----------- block-matcher call! ------------") (debug-newline)
  (debug-write "blocksA = ") (debug-write blocksA) (debug-newline)
  (debug-write "blocksB = ") (debug-write blocksB) (debug-newline)
  (cond 
   ((or (null? blocksA) (null? blocksB))
    (debug-write "Cond Case 0!") (debug-newline)
    '())
   ((equal? (caar blocksA) (caar blocksB))
    (debug-write "Cond Case 1!") (debug-newline)
    (cons (operator (car blocksA) (car blocksB))
          (block-matcher (cdr blocksA) (cdr blocksB) operator)))
   ((ordering-function (caar blocksA) (caar blocksB))
    (debug-write "Cond Case 2!") (debug-newline)
    (block-matcher (cdr blocksA) blocksB operator))
   (else 
    (debug-write "Cond Case 3!") (debug-newline)
    (block-matcher blocksA (cdr blocksB) operator))))

                                        ; weaves together the strings valsA and valsB
(define (combine valsA valsB remaining-varsA remaining-varsB)
  (cond 
   ((null? valsA) valsB)
   ((null? valsB) valsA)
   (else 
    (let ((s (car remaining-varsA))
          (t (car remaining-varsB)))
      (cons (car (if (<= s t) valsA valsB))
            (combine (if (<= s t) 
                         (cdr valsA) 
                         valsA)
                     (if (>= s t) 
                         (cdr valsB) 
                         valsB)
                     (if (<= s t) 
                         (cdr remaining-varsA) 
                         remaining-varsA)
                     (if (>= s t) 
                         (cdr remaining-varsB) 
                         remaining-varsB)))))))

                                        ; multiplies all the elements of blockA with all the elements of blockB
(define (block-multiply blockA blockB varsA varsB)
  (apply append 
         (map 
          (lambda (x) 
            (map 
             (lambda (y) (combine x y varsA varsB))
             blockB))
          blockA)))

                                        ; Join's two canteen's together across their common variables
(define (Join-Canteens canA canB predA)
  (let* ((varsA (car canA))
         (varsB (car canB))
         (trieA (cadr canA))
         (trieB (cadr canB))
         (commonVars (get-intersection varsA varsB))
         (subA (get-sub-canteen commonVars canA))
         (subB (get-sub-canteen commonVars canB))
         (filter1Results1 (filter1 
                           (cadr subA) 
                           (car subB))))
    (debug-write "---------- Join-Canteens ---------") (debug-newline)
    (debug-write "filter1Results1 = ") (debug-write filter1Results1) (debug-newline)
    (let* ((filter1Results2 (keep-matching-items 
                             filter1Results1
                             (lambda (x) (apply predA (cadr x)))))
           (filter1Results3 (filter1 
                             (cadr subB) 
                             (car subA)))
           (blockedA (blockerize filter1Results2))
           (blockedB (blockerize filter1Results3)))
      (Create-Canteen 
       (get-intersection varsA varsB) 
       (apply append 
              (block-matcher 
               blockedA 
               blockedB 
               (lambda (x y) 
                 (block-multiply (cdr x) (cdr y) varsA varsB))))))))


(define (sort-the-predicate-pairs pred-pairs)
  (define (special-ordering a b)
    (ordering-function (car a) (car b)))
  (vector->list (sort! (list->vector pred-pairs) special-ordering)))

(define (get-all-permutations the-lists pred-filter)
  (let ((answer '()))
    (let lp ((remaining-lists the-lists) 
             (cur-string '()))
      (cond 
       ((null? remaining-lists)
        (if (apply pred cur-string)
            (set! answer (cons cur-string answer))))
       ((null? (car remaining-lists))
        (lp (cdr remaining-lists) cur-string))
       (else 
        (lp (cdr remaining-lists) 
            (append cur-string (list (caar remaining-lists))))
        (lp (cons (cdr (car remaining-lists)) (cdr lists))
            cur-string))))
    answer))

#|
                                        ; Initial vector should be of the format 
                                        ; (list->vector '((1 2 3) (1 2 3) (1 2 3) (1 2 3) (1 2 3)))
(define (prune-points init-vector predicate-pairs)
  (let ((rev-sort-pps (reverse (sort-the-predicate-pairs predicate-pairs))))


|#