;;;
;;; plist.scm  ---  a property list system to tag objects
;;;

(define *plists* (make-eq-hash-table))

(define (set-tag! object tag value)
  (let ((table (hash-table/get *plists* object #f)))
    (if (not table)
        (begin
          (set! table (make-eq-hash-table))
          (hash-table/put! *plists* object table)))
    (hash-table/put! table tag value)))

(define (get-tag object tag default)
  (let ((table (hash-table/get *plists* object #f)))
    (if table
        (hash-table/get table tag default)
        default)))

(define (has-tag? object tag)
  (eq? (get-tag object tag #f) (get-tag object tag #t)))